#!/usr/bin/perl

##########################################################
## Weiter nichts ndern ab hier
##########################################################



require "clicount.cfg";

$| = 1;	 # Flush Output Right Away

# Determine if we are printing to command line, or to browser.
$use_html = 0;
$use_html = 1  if($ENV{'REQUEST_METHOD'});

# Print HTTP/HTML Header for nph-scripts
$use_html ?
  print qq|Content-type: text/html\n\n<html><head><title>Backup Programm</title></head><body><h2><tt>Backup Programm</tt></h2><pre>| :
  print qq|Backup Programm\n|;
print &format_time(time())."\n\n";

# Fetching clients data
print "Hole Kunde Daten...\n";
&get_clientsdata;
print "Fertig.\n\n";

# Decreasing log files to minimal size
print "Bearbeite Log Daten...\n";
print "Kunde(n):\n";
&log_decreasing;
print "Fertig.\n\n";

# Saving new clients data
print "Speichere Daten...\n";
&save_clientsdata;
print "Fertig.\n\n";

# Backing up databases
print "Backup Datenbank...\n";
&backup;
print "Fertig.\n\n";

# Finished!
print "Fertiggestellt! - ", &format_time(time()), "\n";
print "</pre></body></html>"  if($use_html);

##########################################################
## Functions
##########################################################

sub get_clientsdata {
# --------------------------------------------------------
# Get all clients data
  open(CLIENTS, '<'.$db_clientsdata_path) or &error("Can't open Clients database. Reason: $!");
  $db_user_flock and (flock(CLIENTS, 1) or &error("Can't get file lock on clients database ($db_clientsdata_path). Reason: $!"));
  while(<CLIENTS>) {
    /\#/ and next;
    chomp;
    /^(.+?)\|(.+?)$/ and $clientsdata{$1} = $1.'|'.$2;
  }
  close CLIENTS;
}

sub save_clientsdata {
# --------------------------------------------------------
# Saves clients database to file.
  open(CLIENTS, '>'.$db_clientsdata_path) or &error("Can't open clients database for writing. Reason: $!");
  $db_user_flock and (flock(CLIENTS, 2) or &error("Can't get exclusive file lock on clients database ($db_clientsdata_path). Reason: $!"));
  for(sort keys %clientsdata) {
    print CLIENTS $clientsdata{$_}, "\n";
  }
  close CLIENTS;
}

sub log_decreasing {
# --------------------------------------------------------
# Decreases log files
  my(@client, $ip, $time, %data, $i);
  
  for(sort keys %clientsdata) {
    @client = split(/\|/, $clientsdata{$_});
    print "  $client[0]: ";
    
    # banners requests log file
    %data = ();  @backup = ();
    open(CLIENT, '<'.$db_data_path."/$client[0]_banner") or &error("Can't open banner requests log file: $client[0]. Reason: $!");
    $db_user_flock and (flock(CLIENT, 1) or &error("Can't get file lock on banner requests log file: $client[0]. Reason: $!"));
    while(<CLIENT>) {
      /^\n$/ and next;
      chomp;
      push(@backup, $_);
    }
    close CLIENT;
    if($#backup + 1 > $db_logdata_lines) {
      $i = $#backup + 1 - $db_logdata_lines;
      open(CLIENT, '>'.$db_data_path."/$client[0]_banner") or &error("Can't open banner requests log file for writing: $client[0]. Reason: $!");
      $db_user_flock and (flock(CLIENT, 2) or &error("Can't get exclusive file lock on banner requests log file: $client[0]. Reason: $!"));
      for(@backup) {
        if($i > 0) {
          ($ip, $time) = split /\|/;
          $client[7]++;  $client[8]++;
          $client[8]--  if($time <= $data{$ip} + $db_cheatprot_tolval);
          $data{$ip} = $time;
          $i--;
        }
        else { print CLIENT $_, "\n"; }
      }
      close CLIENT;
      print "1 ";
    }
    else { print "- "; }
    
    # Clicks log file
    %data = ();  @backup = ();
    open(CLIENT, '<'.$db_data_path."/$client[0]_click") or &error("Can't open clicks log file: $client[0]. Reason: $!");
    $db_user_flock and (flock(CLIENT, 1) or &error("Can't get file lock on clicks log file: $client[0]. Reason: $!"));
    while(<CLIENT>) {
      /^\n$/ and next;
      chomp;
      push(@backup, $_);
    }
    close CLIENT;
    if($#backup + 1 > $db_logdata_lines) {
      $i = $#backup + 1 - $db_logdata_lines;
      open(CLIENT, '>'.$db_data_path."/$client[0]_click") or &error("Can't open clicks log file for writing: $client[0]. Reason: $!");
      $db_user_flock and (flock(CLIENT, 2) or &error("Can't get exclusive file lock on clicks log file: $client[0]. Reason: $!"));
      for(@backup) {
        if($i > 0) {
          ($ip, $time) = split /\|/;
          $client[9]++;  $client[10]++;
          $client[10]--  if($time <= $data{$ip} + $db_cheatprot_tolval);
          $data{$ip} = $time;
          $i--;
        }
        else { print CLIENT $_, "\n"; }
      }
      close CLIENT;
      print "2\n";
    }
    else { print "-\n"; }
    
    # save counters
    $clientsdata{$client[0]} = join("|", @client);
  }
}

sub backup {
# --------------------------------------------------------
# Backups clients and banner databases
  use File::Copy;
  print "  Kunden Datenbank...";
  copy($db_clientsdata_path, "$db_backup_path/clients.db") or &error("unable to make backup $db_backup_path/clients.db! Reason: $!");
  print "OK.\n";
  print "  Banner Datenbank...";
  copy($db_bannersdata_path, "$db_backup_path/banners.db") or &error("unable to make backup $db_backup_path/banners.db! Reason: $!");
  print "OK.\n"
}

sub error {
# --------------------------------------------------------
# Shows an error msg
  my $msg = shift;
  print "\n\nFEHLER: $msg\n";
  print "</pre></body></html>"  if($use_html);
  exit 1;
}
